diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index d7e4749..e01a9ec 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -5821,23 +4390,19 @@ _cl5ExportFile(PRFileDesc *prFile, Object *obj)
     char *buff;
     PRInt32 len, wlen;
     CL5Entry entry;
-    CL5DBFile *file;
 
-    PR_ASSERT(prFile && obj);
-
-    file = (CL5DBFile *)object_get_data(obj);
-    PR_ASSERT(file);
+    PR_ASSERT(prFile && cldb);
 
     if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-        ruv_dump(file->purgeRUV, "clpurgeruv", prFile);
-        ruv_dump(file->maxRUV, "clmaxruv", prFile);
+        ruv_dump(cldb->purgeRUV, "clpurgeruv", prFile);
+        ruv_dump(cldb->maxRUV, "clmaxruv", prFile);
     }
     slapi_write_buffer(prFile, "\n", strlen("\n"));
 
     entry.op = &op;
-    rc = _cl5GetFirstEntry(obj, &entry, &iterator, NULL);
+    rc = _cl5GetFirstEntry(cldb, &entry, &iterator, NULL);
     while (rc == CL5_SUCCESS) {
-        rc = _cl5Operation2LDIF(&op, file->replGen, &buff, &len);
+        rc = _cl5Operation2LDIF(&op, cldb->ident, &buff, &len);
         if (rc != CL5_SUCCESS) {
             slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                           "_cl5ExportFile - Failed to convert operation to ldif\n");
@@ -5875,24 +4440,6 @@ _cl5ExportFile(PRFileDesc *prFile, Object *obj)
     return rc;
 }
 
-static PRBool
-_cl5ReplicaInList(Replica *replica, Replica **replicas)
-{
-    int i;
-
-    PR_ASSERT(replica && replicas);
-
-    /* ONREPL I think it should be sufficient to just compare replica pointers */
-    /* LK not sure about this, but it is only used for changlog import for
-     * multiple changelogs, shozld probably be deprecated anyway */
-    for (i = 0; replicas[i]; i++) {
-        if (replica == replicas[i])
-            return PR_TRUE;
-    }
-
-    return PR_FALSE;
-}
-
 static char *
 _cl5GetHelperEntryKey(int type, char *csnStr)
 {
@@ -5908,338 +4455,99 @@ _cl5GetHelperEntryKey(int type, char *csnStr)
     return rt;
 }
 
-static Replica *
-_cl5GetReplica(const slapi_operation_parameters *op, const char *replGen)
+/*
+ * Write RUVs into the changelog;
+ * implemented for backup to make sure the backed up changelog contains RUVs
+ * Return values: 0 -- success
+ *                1 -- failure
+ */
+static int
+_cl5WriteReplicaRUV(Replica *r, void *arg)
 {
-    Slapi_DN *sdn;
-    Replica *replica;
-    char *newGen;
-
-    PR_ASSERT(op && replGen);
-
-    sdn = op->target_address.sdn;
-
-    replica = replica_get_replica_from_dn(sdn);
-    if (replica) {
-        /* check to see if replica generation has not change */
-        newGen = replica_get_generation(replica);
-        PR_ASSERT(newGen);
-        if (strcmp(replGen, newGen) != 0) {
-            replica = NULL;
-        }
-
-        slapi_ch_free((void **)&newGen);
+    int rc = 0;
+    cldb_Handle *cldb = replica_get_file_info(r);
+ 
+    if (NULL == cldb) {
+        /* TBD should this really happen, do we need an error msg */
+        return rc;
     }
 
-    return replica;
-}
+    _cl5WriteEntryCount(cldb);
+    rc = _cl5WriteRUV(cldb, PR_TRUE);
+    rc = _cl5WriteRUV(cldb, PR_FALSE);
+    ruv_destroy(&cldb->maxRUV);
+    ruv_destroy(&cldb->purgeRUV);
 
-int
-cl5_is_diskfull()
-{
-    int rc;
-    PR_Lock(cl5_diskfull_lock);
-    rc = cl5_diskfull_flag;
-    PR_Unlock(cl5_diskfull_lock);
     return rc;
 }
 
-static void
-cl5_set_diskfull(void)
-{
-    PR_Lock(cl5_diskfull_lock);
-    cl5_diskfull_flag = 1;
-    PR_Unlock(cl5_diskfull_lock);
-}
-
-static void
-cl5_set_no_diskfull(void)
-{
-    PR_Lock(cl5_diskfull_lock);
-    cl5_diskfull_flag = 0;
-    PR_Unlock(cl5_diskfull_lock);
-}
-
-int
-cl5_diskspace_is_available()
+static char *
+_cl5LdifFileName(char *instance_ldif)
 {
-    int rval = 1;
+    char *cl_ldif = NULL;
+    char *p =strstr(instance_ldif, ".ldif");
 
-#if defined(OS_solaris) || defined(hpux)
-    struct statvfs fsbuf;
-    if (statvfs(s_cl5Desc.dbDir, &fsbuf) < 0) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "cl5_diskspace_is_available - Cannot get file system info\n");
-        rval = 0;
-    } else {
-        unsigned long fsiz = fsbuf.f_bavail * fsbuf.f_frsize;
-        if (fsiz < NO_DISK_SPACE) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "cl5_diskspace_is_available - No enough diskspace for changelog: (%u bytes free)\n", fsiz);
-            rval = 0;
-        } else if (fsiz > MIN_DISK_SPACE) {
-            /* assume recovered */
-            cl5_set_no_diskfull();
-        }
-    }
-#endif
-#if defined(linux)
-    struct statfs fsbuf;
-    if (statfs(s_cl5Desc.dbDir, &fsbuf) < 0) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "cl5_diskspace_is_available - Cannot get file system info\n");
-        rval = 0;
+    if (p) {
+        *p = '\0';
+        cl_ldif = slapi_ch_smprintf("%s_cl.ldif", instance_ldif);
     } else {
-        unsigned long fsiz = fsbuf.f_bavail * fsbuf.f_bsize;
-        if (fsiz < NO_DISK_SPACE) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "cl5_diskspace_is_available - No enough diskspace for changelog: (%lu bytes free)\n", fsiz);
-            rval = 0;
-        } else if (fsiz > MIN_DISK_SPACE) {
-            /* assume recovered */
-            cl5_set_no_diskfull();
-        }
+        cl_ldif = slapi_ch_smprintf("%s_cl", instance_ldif);
     }
-#endif
-    return rval;
-}
-
-int
-cl5DbDirIsEmpty(const char *dir)
-{
-    PRDir *prDir;
-    PRDirEntry *prDirEntry;
-    int isempty = 1;
 
-    if (!dir || !*dir) {
-        return isempty;
-    }
-    /* assume failure means it does not exist - other failure
-       cases will be handled by code which attempts to create the
-       db in this directory */
-    if (PR_Access(dir, PR_ACCESS_EXISTS)) {
-        return isempty;
-    }
-    prDir = PR_OpenDir(dir);
-    if (prDir == NULL) {
-        return isempty; /* assume failure means does not exist */
-    }
-    while (NULL != (prDirEntry = PR_ReadDir(prDir, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (NULL == prDirEntry->name) { /* NSPR doesn't behave like the docs say it should */
-            break;
-        }
-        isempty = 0; /* found at least one "real" file */
-        break;
-    }
-    PR_CloseDir(prDir);
+    return cl_ldif;
 
-    return isempty;
 }
 
-/*
- * Write RUVs into the changelog;
- * implemented for backup to make sure the backed up changelog contains RUVs
- * Return values: 0 -- success
- *                1 -- failure
- */
 int
-cl5WriteRUV()
+cl5Import(Slapi_PBlock *pb)
 {
-    int rc = 0;
-    Object *file_obj = NULL;
-    CL5DBFile *dbfile = NULL;
-    int closeit = 0;
-    int slapd_pid = 0;
-
-    changelog5Config config;
-
-    /* read changelog configuration */
-    changelog5_read_config(&config);
-    if (config.dir == NULL) {
-        /* Changelog is not configured; Replication is not enabled.
-         * we don't have to update RUVs.
-         * bail out - return success */
-        goto bail;
-    }
-
-    slapd_pid = is_slapd_running();
-    if (slapd_pid <= 0) {
-        /* I'm not a server, rather a utility.
-         * And the server is NOT running.
-         * RUVs should be in the changelog.
-         * we don't have to update RUVs.
-         * bail out - return success */
-        goto bail;
-    }
-
-    if (getpid() != slapd_pid) {
-        /* I'm not a server, rather a utility.
-         * And the server IS running.
-         * RUVs are not in the changelog and no easy way to retrieve them.
-         * bail out - return failure */
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "cl5WriteRUV - server (pid %d) is already running; bail.\n",
-                      slapd_pid);
-        rc = 1;
-        goto bail;
-    }
-
-    /* file is stored in the changelog directory and is named
-     *        <replica name>.ldif */
-    if (CL5_STATE_OPEN != s_cl5Desc.dbState) {
-        rc = _cl5Open(config.dir, &config.dbconfig, CL5_OPEN_NORMAL);
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "cl5WriteRUV - Failed to open changelog\n");
-            goto bail;
-        }
-        s_cl5Desc.dbState = CL5_STATE_OPEN; /* force to change the state */
-        closeit = 1;                        /* It had not been opened; close it */
-    }
-
-    file_obj = objset_first_obj(s_cl5Desc.dbFiles);
-    while (file_obj) {
-        dbfile = (CL5DBFile *)object_get_data(file_obj);
-        if (dbfile) {
-            _cl5WriteEntryCount(dbfile);
-            _cl5WriteRUV(dbfile, PR_TRUE);
-            _cl5WriteRUV(dbfile, PR_FALSE);
-        }
-        file_obj = objset_next_obj(s_cl5Desc.dbFiles, file_obj);
-    }
-bail:
-    if (closeit && (CL5_STATE_OPEN == s_cl5Desc.dbState)) {
-        _cl5Close();
-        s_cl5Desc.dbState = CL5_STATE_CLOSED; /* force to change the state */
-    }
-    changelog5_config_done(&config);
-    return rc;
+    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                          "cl5Export - Importing changelog\n");
+    return 0;
 }
 
-/*
- * Delete RUVs from the changelog;
- * implemented for backup to clean up RUVs
- * Return values: 0 -- success
- *                1 -- failure
- */
 int
-cl5DeleteRUV()
+cl5Export(Slapi_PBlock *pb)
 {
-    int rc = 0;
-    Object *file_obj = NULL;
-    CL5DBFile *dbfile = NULL;
-    int slapd_pid = 0;
-    int closeit = 0;
-
-    changelog5Config config;
-
-    /* read changelog configuration */
-    changelog5_read_config(&config);
-    if (config.dir == NULL) {
-        /* Changelog is not configured; Replication is not enabled.
-         * we don't have to update RUVs.
-         * bail out - return success */
-        goto bail;
-    }
-
-    slapd_pid = is_slapd_running();
-    if (slapd_pid <= 0) {
-        /* I'm not a server, rather a utility.
-         * And the server is NOT running.
-         * RUVs should be in the changelog.
-         * we don't have to update RUVs.
-         * bail out - return success */
-        goto bail;
-    }
-
-    if (getpid() != slapd_pid) {
-        /* I'm not a server, rather a utility.
-         * And the server IS running.
-         * RUVs are not in the changelog.
-         * bail out - return success */
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "cl5DeleteRUV - server (pid %d) is already running; bail.\n",
-                      slapd_pid);
-        goto bail;
-    }
+    char *instance_name;
+    char *instance_ldif;
+    char *instance_cl_ldif;
+    Slapi_Backend *be;
+    Replica *replica = NULL;
+    int rc;
 
-    /* file is stored in the changelog directory and is named
-     *        <replica name>.ldif */
-    if (CL5_STATE_OPEN != s_cl5Desc.dbState) {
-        rc = _cl5Open(config.dir, &config.dbconfig, CL5_OPEN_NORMAL);
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "cl5DeleteRUV - Failed to open changelog\n");
-            goto bail;
-        }
-        s_cl5Desc.dbState = CL5_STATE_OPEN; /* force to change the state */
-        closeit = 1;                        /* It had been opened; no need to close */
+    slapi_pblock_get(pb, SLAPI_BACKEND_INSTANCE_NAME, &instance_name);
+    slapi_pblock_get(pb, SLAPI_DB2LDIF_FILE, &instance_ldif);
+    slapi_pblock_get(pb, SLAPI_BACKEND, &be);
+    replica = replica_get_replica_from_dn(slapi_be_getsuffix(be, 0));
+    if (replica == NULL) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                              "cl5Export - No replica defined for instance %s\n", instance_name);
+        return 0;
     }
 
-    file_obj = objset_first_obj(s_cl5Desc.dbFiles);
-    while (file_obj) {
-        dbfile = (CL5DBFile *)object_get_data(file_obj);
+    instance_cl_ldif = _cl5LdifFileName(instance_ldif);
+    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                  "cl5Export - Exporting changelog for instance %s to file %s\n",
+                  instance_name, instance_cl_ldif);
+    rc = cl5ExportLDIF(instance_cl_ldif, replica);
 
-        /* _cl5GetEntryCount deletes entry count after reading it */
-        rc = _cl5GetEntryCount(dbfile);
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "cl5DeleteRUV - Failed to get/delete entry count\n");
-            goto bail;
-        }
-        /* _cl5ReadRUV deletes RUV after reading it */
-        rc = _cl5ReadRUV(dbfile->replGen, file_obj, PR_TRUE);
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "cl5DeleteRUV - Failed to read/delete purge RUV\n");
-            goto bail;
-        }
-        rc = _cl5ReadRUV(dbfile->replGen, file_obj, PR_FALSE);
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "cl5DeleteRUV - Failed to read/delete upper bound RUV\n");
-            goto bail;
-        }
-        file_obj = objset_next_obj(s_cl5Desc.dbFiles, file_obj);
-    }
-bail:
-    if (file_obj) {
-        object_release(file_obj);
-    }
-    if (closeit && (CL5_STATE_OPEN == s_cl5Desc.dbState)) {
-        _cl5Close();
-        s_cl5Desc.dbState = CL5_STATE_CLOSED; /* force to change the state */
-    }
-    changelog5_config_done(&config);
     return rc;
 }
-
 /*
  *  Clean the in memory RUV, at shutdown we will write the update to the db
  */
 void
-cl5CleanRUV(ReplicaId rid)
+cl5CleanRUV(ReplicaId rid, Replica *replica)
 {
-    CL5DBFile *file;
-    Object *obj = NULL;
-
-    slapi_rwlock_wrlock(s_cl5Desc.stLock);
-
-    obj = objset_first_obj(s_cl5Desc.dbFiles);
-    while (obj) {
-        file = (CL5DBFile *)object_get_data(obj);
-        ruv_delete_replica(file->purgeRUV, rid);
-        ruv_delete_replica(file->maxRUV, rid);
-        obj = objset_next_obj(s_cl5Desc.dbFiles, obj);
-    }
-
-    slapi_rwlock_unlock(s_cl5Desc.stLock);
+    cldb_Handle *cldb = replica_get_file_info(replica);
+    ruv_delete_replica(cldb->purgeRUV, rid);
+    ruv_delete_replica(cldb->maxRUV, rid);
 }
 
 static void
 free_purge_data(cleanruv_purge_data *purge_data)
 {
-    slapi_ch_free_string(&purge_data->replGen);
     slapi_ch_free((void **)&purge_data);
 }
 
@@ -6300,3 +4608,18 @@ trigger_cl_purging_thread(void *arg)
 free_and_return:
     free_purge_data(purge_data);
 }
+
+char *
+cl5GetLdifDir(Slapi_Backend *be)
+{
+    char *dir = NULL;
+    char *dbdir = NULL;
+
+    if (NULL == be) {
+        dir = slapi_ch_strdup("/tmp");
+    } else {
+        slapi_back_get_info(be, BACK_INFO_DIRECTORY, (void **)&dbdir);
+        dir = slapi_ch_smprintf("%s/../ldif",dbdir);
+    }
+    return dir;
+}
diff --git a/ldap/servers/plugins/replication/cl5_api.h b/ldap/servers/plugins/replication/cl5_api.h
index 302af97..85927a7 100644
--- a/ldap/servers/plugins/replication/cl5_api.h
+++ b/ldap/servers/plugins/replication/cl5_api.h
@@ -36,15 +36,6 @@
 
 /***** Data Structures *****/
 
-/* changelog configuration structure */
-typedef struct cl5dbconfig
-{
-    uint32_t pageSize;           /* page size in bytes */
-    PRInt32 fileMode;          /* file mode */
-    char *encryptionAlgorithm; /* nsslapd-encryptionalgorithm */
-    char *symmetricKey;
-} CL5DBConfig;
-
 /* changelog entry format */
 typedef struct cl5entry
 {
@@ -81,6 +72,9 @@ typedef struct cl5entry
 /* data structure that allows iteration through changelog */
 typedef struct cl5replayiterator CL5ReplayIterator;
 
+/* database information for th echangelog */
+typedef struct cl5DBFileHandle cldb_Handle;
+
 /* changelog state */
 typedef enum {
     CL5_STATE_NONE,    /* changelog has not been initialized */
@@ -137,9 +131,6 @@ void cl5Cleanup(void);
    Description:    opens changelog ; must be called after changelog is
                 initialized using cl5Init. It is thread safe and the second
                 call is ignored.
-   Parameters:  dir - changelog dir
-                config - db configuration parameters; currently not used
-                openMode - open mode
    Return:        CL5_SUCCESS if successful;
                 CL5_BAD_DATA if invalid directory is passed;
                 CL5_BAD_DBVERSION if dbversion file is missing or has unexpected data
@@ -147,7 +138,7 @@ void cl5Cleanup(void);
                 CL5_MEMORY_ERROR if memory allocation fails;
                 CL5_DB_ERROR if db initialization or open fails.
  */
-int cl5Open(const char *dir, const CL5DBConfig *config);
+int cl5Open(void);
 
 /* Name:        cl5Close
    Description:    closes changelog and cleanups changelog module; waits until
@@ -159,21 +150,11 @@ int cl5Open(const char *dir, const CL5DBConfig *config);
  */
 int cl5Close(void);
 
-/* Name:        cl5Delete
-   Description:    removes changelog
-   Parameters:  dir - changelog directory
-   Return:        CL5_SUCCESS if successful;
-                CL5_BAD_STATE if the changelog is not in closed state;
-                CL5_BAD_DATA if invalid directory supplied
-                CL5_SYSTEM_ERROR if NSPR call fails
- */
-int cl5Delete(const char *dir);
-
-/* Name:        cl5DeleteDBSync
-   Description: The same as cl5DeleteDB except the function does not return
-                until the file is removed.
+/* Name:        cldb_RemoveReplicaDB
+   Description: Clear the cldb information from the replica 
+                and delete the database file
 */
-int cl5DeleteDBSync(Replica *replica);
+int cldb_RemoveReplicaDB(Replica *replica);
 
 /* Name:        cl5GetUpperBoundRUV
    Description: retrieves vector that represent the upper bound of changes
@@ -202,7 +183,7 @@ int cl5GetUpperBoundRUV(Replica *r, RUV **ruv);
                 CL5_SYSTEM_ERROR if NSPR call fails;
                 CL5_MEMORY_ERROR if memory allocation fails.
  */
-int cl5ExportLDIF(const char *ldifFile, Replica **replicas);
+int cl5ExportLDIF(const char *ldifFile, Replica *replica);
 
 /* Name:        cl5ImportLDIF
    Description:    imports ldif file into changelog; changelog must be in the closed state
@@ -217,7 +198,7 @@ int cl5ExportLDIF(const char *ldifFile, Replica **replicas);
                 CL5_SYSTEM_ERROR if NSPR call fails;
                 CL5_MEMORY_ERROR if memory allocation fails.
  */
-int cl5ImportLDIF(const char *clDir, const char *ldifFile, Replica **replicas);
+int cl5ImportLDIF(const char *clDir, const char *ldifFile, Replica *replica);
 
 /* Name:        cl5GetState
    Description:    returns database state
@@ -231,12 +212,11 @@ int cl5GetState(void);
    Description:    sets changelog trimming parameters
    Parameters:  maxEntries - maximum number of entries in the log;
                 maxAge - maximum entry age;
-                compactInterval - interval to compact changelog db;
                 trimInterval - interval for changelog trimming.
    Return:        CL5_SUCCESS if successful;
                 CL5_BAD_STATE if changelog has not been open
  */
-int cl5ConfigTrimming(int maxEntries, const char *maxAge, int compactInterval, int trimInterval);
+int cl5ConfigTrimming(Replica *replica, int maxEntries, const char *maxAge, int trimInterval);
 
 void cl5DestroyIterator(void *iterator);
 
@@ -248,7 +228,6 @@ void cl5DestroyIterator(void *iterator);
                    replica object since generation can change while operation
                    is in progress (if the data is reloaded). !!!
                 op - operation to write
-                local - this is a non-replicated operation
                 txn - the containing transaction
    Return:        CL5_SUCCESS if function is successful;
                 CL5_BAD_DATA if invalid op is passed;
@@ -256,7 +235,7 @@ void cl5DestroyIterator(void *iterator);
                 CL5_MEMORY_ERROR if memory allocation failed;
                 CL5_DB_ERROR if any other db error occurred;
  */
-int cl5WriteOperationTxn(const char *repl_name, const char *repl_gen, const slapi_operation_parameters *op, PRBool local, void *txn);
+int cl5WriteOperationTxn(cldb_Handle *cldb, const slapi_operation_parameters *op, void *txn);
 
 /* Name:        cl5WriteOperation
    Description:    writes operation to changelog
@@ -266,14 +245,13 @@ int cl5WriteOperationTxn(const char *repl_name, const char *repl_gen, const slap
                    replica object since generation can change while operation
                    is in progress (if the data is reloaded). !!!
                 op - operation to write
-                local - this is a non-replicated operation
    Return:        CL5_SUCCESS if function is successful;
                 CL5_BAD_DATA if invalid op is passed;
                 CL5_BAD_STATE if db has not been initialized;
                 CL5_MEMORY_ERROR if memory allocation failed;
                 CL5_DB_ERROR if any other db error occurred;
  */
-int cl5WriteOperation(const char *repl_name, const char *repl_gen, const slapi_operation_parameters *op, PRBool local);
+int cl5WriteOperation(cldb_Handle *cldb, const slapi_operation_parameters *op);
 
 /* Name:        cl5CreateReplayIterator
    Description:    creates an iterator that allows to retrieve changes that should
@@ -321,29 +299,13 @@ int cl5GetNextOperationToReplay(CL5ReplayIterator *iterator,
  */
 void cl5DestroyReplayIterator(CL5ReplayIterator **iterator);
 
-/* Name:        cl5DeleteOnClose
-   Description:    marks changelog for deletion when it is closed
-   Parameters:  flag; if flag = 1 then delete else don't
-   Return:        none
- */
-
-void cl5DeleteOnClose(PRBool rm);
-
-/* Name:        cl5GetDir
-   Description:    returns changelog directory; must be freed by the caller;
-   Parameters:  none
+/* Name:        cl5GetLdifDir
+   Description:    returns the default ldif directory; must be freed by the caller;
+   Parameters:  backend used for export/import
    Return:        copy of the directory; caller needs to free the string
  */
 
-char *cl5GetDir(void);
-
-/* Name: cl5Exist
-   Description: checks if a changelog exists in the specified directory
-   Parameters: clDir - directory to check;
-   Return: 1 - if changelog exists; 0 - otherwise
- */
-
-PRBool cl5Exist(const char *clDir);
+char *cl5GetLdifDir(Slapi_Backend *be);
 
 /* Name: cl5GetOperationCount
    Description: returns number of entries in the changelog. The changelog must be
@@ -371,39 +333,24 @@ void cl5_operation_parameters_done(struct slapi_operation_parameters *sop);
 */
 
 int cl5CreateDirIfNeeded(const char *dir);
-int cl5DBData2Entry(const char *data, PRUint32 len, CL5Entry *entry);
+int cl5DBData2Entry(const char *data, PRUint32 len, CL5Entry *entry, void *clcrypt_handle);
 
 PRBool cl5HelperEntry(const char *csnstr, CSN *csn);
 CSN **cl5BuildCSNList(const RUV *consRuv, const RUV *supRuv);
 void cl5DestroyCSNList(CSN ***csns);
 
-int cl5_is_diskfull(void);
-int cl5_diskspace_is_available(void);
+int cl5Export(Slapi_PBlock *pb);
+int cl5Import(Slapi_PBlock *pb);
 
-/* Name: cl5DbDirIsEmpty
-   Description: See if the given cldb directory is empty or doesn't yet exist.
-   Parameters:    dir - Contains the name of the directory.
-   Return:        TRUE - directory does not exist or is empty, is NULL, or is
-                       an empty string
-                FALSE - otherwise
-*/
-int cl5DbDirIsEmpty(const char *dir);
-
-/* Name: cl5WriteRUV
-   Description: Write RUVs into changelog db's.  Called before backup.
-   Parameters:    none
-   Return:        TRUE
-*/
-int cl5WriteRUV(void);
+int cl5NotifyRUVChange(Replica *replica);
 
-/* Name: cl5DeleteRUV
-   Description: Read and delete RUVs from changelog db's.  Called after backup.
-   Parameters:    none
-   Return:        TRUE
-*/
-int cl5DeleteRUV(void);
-void cl5CleanRUV(ReplicaId rid);
+void cl5CleanRUV(ReplicaId rid, Replica *replica);
 void cl5NotifyCleanup(int rid);
 void trigger_cl_purging(cleanruv_purge_data *purge_data);
+int cldb_SetReplicaDB(Replica *replica, void *arg);
+int cldb_UnSetReplicaDB(Replica *replica, void *arg);
+int cldb_StartTrimming(Replica *replica);
+int cldb_StopTrimming(Replica *replica, void *arg);
+int cldb_StopThreads(Replica *replica, void *arg);
 
 #endif
diff --git a/ldap/servers/plugins/replication/cl5_clcache.c b/ldap/servers/plugins/replication/cl5_clcache.c
index 6b591fb..e867880 100644
--- a/ldap/servers/plugins/replication/cl5_clcache.c
+++ b/ldap/servers/plugins/replication/cl5_clcache.c
@@ -129,7 +129,6 @@ struct clc_busy_list
 struct clc_pool
 {
     Slapi_RWLock *pl_lock;        /* cl writer and agreements */
-    DB_ENV **pl_dbenv;            /* pointer to DB_ENV for all the changelog files */
     CLC_Busy_List *pl_busy_lists; /* busy buffer lists, one list per changelog file */
     int pl_buffer_cnt_now;        /* total number of buffers */
     int pl_buffer_cnt_min;        /* free a newly returned buffer if _now > _min */
@@ -163,16 +162,12 @@ static void csn_dup_or_init_by_csn(CSN **csn1, CSN *csn2);
  * once and only once when process starts.
  */
 int
-clcache_init(DB_ENV **dbenv)
+clcache_init(void)
 {
     if (_pool) {
         return 0; /* already initialized */
     }
-    if (NULL == dbenv) {
-        return -1;
-    }
     _pool = (struct clc_pool *)slapi_ch_calloc(1, sizeof(struct clc_pool));
-    _pool->pl_dbenv = dbenv;
     _pool->pl_buffer_cnt_min = DEFAULT_CLC_BUFFER_COUNT_MIN;
     _pool->pl_buffer_cnt_max = DEFAULT_CLC_BUFFER_COUNT_MAX;
     _pool->pl_buffer_default_pages = DEFAULT_CLC_BUFFER_COUNT_MAX;
@@ -399,12 +394,6 @@ clcache_load_buffer_bulk(CLC_Buffer *buf, int flag)
     int tries = 0;
     int use_flag = flag;
 
-#if 0 /* txn control seems not improving anything so turn it off */
-    if ( *(_pool->pl_dbenv) ) {
-        txn_begin( *(_pool->pl_dbenv), NULL, &txn, 0 );
-    }
-#endif
-
     if (NULL == buf) {
         slapi_log_err(SLAPI_LOG_ERR, get_thread_private_agmtname(),
                       "clcache_load_buffer_bulk - NULL buf\n");
@@ -1152,7 +1141,6 @@ clcache_destroy()
             bl = next;
         }
         _pool->pl_busy_lists = NULL;
-        _pool->pl_dbenv = NULL;
         if (_pool->pl_lock) {
             slapi_rwlock_unlock(_pool->pl_lock);
             slapi_destroy_rwlock(_pool->pl_lock);
diff --git a/ldap/servers/plugins/replication/cl5_clcache.h b/ldap/servers/plugins/replication/cl5_clcache.h
index 73eb415..b5b0170 100644
--- a/ldap/servers/plugins/replication/cl5_clcache.h
+++ b/ldap/servers/plugins/replication/cl5_clcache.h
@@ -20,7 +20,7 @@
 
 typedef struct clc_buffer CLC_Buffer;
 
-int clcache_init(DB_ENV **dbenv);
+int clcache_init(void);
 void clcache_set_config(void);
 int clcache_get_buffer(CLC_Buffer **buf, DB *db, ReplicaId consumer_rid, const RUV *consumer_ruv, const RUV *local_ruv);
 int clcache_load_buffer(CLC_Buffer *buf, CSN **anchorCSN, int *continue_on_miss);
